#define KDIM		3	    /* max. Gitterdimension */
#define K2DIM		6	    /* max. Schluessellaenge */
#define MAXNELEM	715000000   /* bei 32 bit unsigned */
#define LEER            0           /* (TMelem *)0 */

#ifndef NULL
#define NULL (char *)0
#endif

typedef double TMval;
typedef short int TMkey;

typedef struct tmelem
{
   struct tmelem  *next;   /* Verkettung */
   TMkey	  k[KDIM]; /* Schluessel (Gitterkoordinaten) */
   short	  m;	   /* Markierung */
   TMval	  w;	   /* Wert */
} TMelem;

typedef struct
{
   TMelem	*tm_elem[10]; /* TM-Elementliste */
} TMelist;

typedef struct tmelpk
{
   struct tmelpk  *next;      /* Verkettung */
   TMkey	  k[K2DIM];   /* Schluessel (Gitterkoordinaten-Paare) */
   TMval	  pkt[KDIM];  /* Schnittpunkt */
   TMval	  *nv;	      /* Verweis auf Normalvektor */
} TMelpk;

typedef struct
{
   int			tsize,	    /* Tabellen-Groesse */
			wref;	    /* Anzahl der Zugriffe auf Tabellenwerte */
   unsigned short int	tdim,	    /* Gitterdimension */
			maxLk,	    /* maximale Kettenlaenge */
			typ;	    /* Typ der Tabelle */
   TMkey		tmax[KDIM]; /* max. Tabellenaufloesung pro Dimension */
   TMelist		*tm_elist;  /* Verweis auf Element-Liste */
} TMtab;
