#include <stdio.h>
#include <setjmp.h>

#define repeat	for(;;)
#define MAXBUF 250		    /* max. Pufferlaenge fuer Formel */
#define MAXTMP	50		    /* max. Anzahl von temporaeren Strings fuer Formel definition */

jmp_buf restart;				 /* Neustart-Adresse bei Syntax-Fehler */

main ()
{
   short i, k, L;
   char txt1[MAXBUF], 
	*txtf, 
	*tp,
	*tmptxt[MAXTMP];
   double w, p[3];
   extern double atof();
   extern char *fgets();
   extern int F_ini();
   extern double F_val();
   printf( "** Fkt - Formel-Auswerter\n");

   do
   {
      setjmp(restart);

      while (( printf( "-- Init-Formel: " ), 
	    !((tp = fgets(txt1,MAXBUF,stdin)) == NULL || strlen(tp) < 3)))
      {
	 txt1[strlen(txt1)-1] = '#';

	 if ( F_ini( txt1 ))
	    exit();
      }

      printf( "-- Formel: " );

      if ((tp = fgets(txt1,MAXBUF,stdin)) && (k = strlen(tp)) > 2)
      {
	 if (txtf)
	    free(txtf);

	 txtf = NULL;
	 i = L = 0;

	 repeat
	 {
	    txt1[--k] = '\0';		/* Linefeed loeschen */
	    L += k;
	    tmptxt[i] = emalloc((unsigned) k+1);
	    strcpy( tmptxt[i++], txt1 );

	    if ( !(tp = fgets(txt1,MAXBUF,stdin)) || (k = strlen(tp)) < 3)
	       break;
	 }

	 if ( L < 3 )
	 {
	    printf("!! Keine Formel definiert !\n" );
	    continue;
	 }

	 txtf = emalloc((unsigned) L+2);
	 *txtf = '\0';

	 for (k = 0;  k < i;  k++)
	 {
	    strcat( txtf, tmptxt[k]);
	    free(tmptxt[k]);
	 }

	 txtf[L] = '#';   txtf[L+1] = '\0';
      }
      else if ( txtf == NULL )
      {
	 printf("!! Keine Formel definiert !\n" );
	 continue;
      }

      F_def( txtf, "x,y,z", .0 );
      
      while (( printf( "-- x,y,z : " ), 
	     tp = fgets( txt1, MAXBUF, stdin )) != NULL && strlen(tp) > 1)
      {
	 p[0] = atof( tp );
	 tp   = strchr( txt1, ',' );

	 if (tp)
	 {
	    p[1] = atof( ++tp );
	    tp   = strchr( tp, ',' );

	    if (tp)
	       p[2] = atof( ++tp );
	 }

	 w = F_val(p);
	 printf( "++ f(%g,%g,%g) = %g\n", p[0], p[1], p[2], w );
      }

      printf( "-- Neustart (j/n) : " );
      tp = fgets( txt1, 80, stdin );
    } while (tp != NULL && *tp == 'j');
}
