/*
 *			f l e x . h
 */


/*
)EDITLEVEL=10
 *
 * Edit history
 * 0.0  4-May-81 JSL	Invention
 * 0.1  7-May-81 JSL	Various cleanups; added FXDODEFS
 * 0.2 13-May-81 JSL	Added _FLEX_
 * 0.3 22-Jun-81 JSL	Conversion to new documentation conventions
 * 0.4 14-Jul-82 JSL	FSDODEFS is obsolete; new compiler is more clever
 */

#ifndef _FLEX_				/* Don't do this twice */
#define _FLEX_

typedef struct fxheader
	{ char *fxdata;
	  unsigned fxused;
	  unsigned fxdim;
	  unsigned fxisz;
	  unsigned fxext;
	} FLEX;

	extern FLEX	*flex();	/* make a new flex */
	extern FLEX	*fxadd();	/* add an item to the end */
	extern FLEX	*fxaddo();	/* add an item, ordered */
	extern unsigned	fxladd;		/* where fxaddo() added an item */
	extern FLEX	*fxeject();	/* eject (delete) an item */
	extern		fxfree();	/* free all space used by a flex */
	extern FLEX	*fxinject();	/* inject (insert) an item */
	extern char	*fxitem();	/* return pointer to an item */
	extern FLEX	*fxneed();	/* explicitly alter a flex's size */
/*
	extern FLEX	*fxset(); */	/* set a value into an item */
#endif
